/*************************************************************************************
Data Visualization - 3D Project Dewey 500
Tested in Processing 3                                    
                                                     
Author: Sarah Wells                      
Supervisor: George Legrady                           

Purpose:     

Usage:    1. A mouse left-drag will rotate the camera around the subject.
          2. A right drag will zoom in and out. 
          3. A middle-drag (command-left-drag on mac) will pan. 
          4. A double-click restores the camera to its original position. 
          5. The shift key constrains rotation and panning to one axis or the other.
          6. Arrows or number keys 1,2,3,4 to view Adult Books, Adult Videos, Child Books, Child Videos
          7. Scroll over point to see info, size proportional to avg checkout time.
*************************************************************************************/

import peasy.*;
PeasyCam cam;

Table table, titleTable, titleYear, deweyClasses;
int numRows, titleNumRows, titleYearNumRows, deweyNumRows;
int temp =0;
float dewey, coutTime;
String title, date, age, itemType, type;
int count;
int abcount, avcount, cbcount, cvcount;
int maxCount=0;
int titleMaxCount=0;
float abcoutTime, avcoutTime, cbcoutTime, cvcoutTime;
float maxcoutTime=0;
float titleMaxcoutTime=0;
int setting = 0;
//arraylist - dynamic space instead of set number 2,3
//book data format - end parenthesis
ArrayList<DeweyRef> deweyNames = new ArrayList<DeweyRef>();
ArrayList<Title> titles = new ArrayList<Title>();
ArrayList<Title> titlesYear = new ArrayList<Title>();
ArrayList<Dewey> abdeweys = new ArrayList<Dewey>();
ArrayList<Dewey> cbdeweys = new ArrayList<Dewey>();
ArrayList<Dewey> avdeweys = new ArrayList<Dewey>();
ArrayList<Dewey> cvdeweys = new ArrayList<Dewey>();
ArrayList<Dewey> tempDeweys = new ArrayList<Dewey>();
ArrayList[] allDeweys = {abdeweys, cbdeweys, avdeweys, cvdeweys};
//keep track of
int[][] deweyTypeCount;

void setup(){
  size(1000, 1000, P3D);
  //200 is how far back
  cam = new PeasyCam(this, 200);
  cam.setWheelScale(0.1);
  //coordinate origin = center camera x,y,z
  colorMode(HSB);
  //load table
  table = loadTable("500broader.csv", "header");
  titleTable = loadTable("500titles.csv", "header");
  titleYear = loadTable("500titlesyear.csv", "header");
  deweyClasses = loadTable("deweyClasses.csv");
  deweyNumRows = deweyClasses.getRowCount();
  titleYearNumRows = titleYear.getRowCount();
  titleNumRows = titleTable.getRowCount();
  numRows = table.getRowCount();
  println("Rows: " + numRows);
  
  for(int i=500; i<599; i++){
    deweyNames.add(new DeweyRef(i, deweyClasses.getString(i,1)));
  }
  
   for(int i=0; i<titleYearNumRows; i++){
    dewey = titleYear.getFloat(i,0);
    date = titleYear.getString(i,1);
    title = titleYear.getString(i,2);
    itemType = titleYear.getString(i,3);
    count = min(2200,titleYear.getInt(i,4));
    coutTime = min(2200,titleYear.getFloat(i,5));
   // float tempxcor = map(dewey, 500, 600, -50, 50);
   // float tempycor = map(count, 0, 100, -50, 50);
   // float tempzcor = map(dateParser(date), 0, 13*14-11, -50, 50);
    maxCount = max(maxCount, titleYear.getInt(i,4));
    maxcoutTime = max(maxcoutTime, titleYear.getInt(i,5));
   // if(itemType.startsWith("j") && itemType.endsWith("bk")){
   //   age = "Child";
   //   type = "Book";
   // }
   // else if(itemType.startsWith("a") && itemType.endsWith("bk")){
   //   age = "Adult";
   //   type = "Book";
   // }
   // else if(itemType.startsWith("j")&& !itemType.endsWith("bk")){
   //   age = "Child";
   //   type = "Video";
   //   }
   //else if(itemType.startsWith("a")&& !itemType.endsWith("bk")){
   //   age = "Adult";
   //   type = "Video";
   //   }
   //   titlesYear.add(new Title(title, dewey, date, count, coutTime, age, type, tempxcor, tempycor, tempzcor));
  }
  println(maxCount);
  println(maxcoutTime);

  maxCount = 0;
  maxcoutTime = 0;
  
 for(int i=0; i<titleNumRows; i++){
    dewey = titleTable.getFloat(i,0);
    date = titleTable.getString(i,1);
    title = titleTable.getString(i,2);
    itemType = titleTable.getString(i,3);
    count = max(100,titleTable.getInt(i,4));
    coutTime = max(200,titleTable.getFloat(i,5));
    float tempxcor = map(dewey, 500, 600, -50, 50);
    float tempycor = map(count, 0, 100, -50, 50);
    
    float tempzcor = map(dateParser(date), 0, 13*14-11, -50, 50);
    if(itemType.startsWith("j") && itemType.endsWith("bk")){
      age = "Child";
      type = "Book";
    }
    else if(itemType.startsWith("a") && itemType.endsWith("bk")){
      age = "Adult";
      type = "Book";
    }
    else if(itemType.startsWith("j")&& !itemType.endsWith("bk")){
      age = "Child";
      type = "Video";
      }
   else if(itemType.startsWith("a")&& !itemType.endsWith("bk")){
      age = "Adult";
      type = "Video";
      }
      titles.add(new Title(title, dewey, date, count, coutTime, age, type, tempxcor, tempycor, tempzcor));
  }
  
  
  deweyTypeCount = new int [100][4];
  dewey = int(table.getFloat(0,0));
  date = table.getString(0,1);
  //by year instead
  //date = table.getString(0,1).substring(0,4);
  abcount = 0;
  abcoutTime = 0;
  avcount = 0;
  avcoutTime = 0;
  cbcount = 0;
  cbcoutTime = 0;
  cvcount = 0;
  cvcoutTime = 0;
  

  for(int i=temp; i<numRows; i++){
        itemType = table.getString(i,2);
        int tempcount = table.getInt(i,3);
        float tempcoutTime = table.getInt(i,4);
        if(tempcoutTime>120){
          tempcoutTime = 120;
        }
    if(table.getFloat(i,0)>= dewey && table.getFloat(i,0)<(dewey+1) && table.getString(i,1).equals(date)){
    //by year instead
    //if(table.getFloat(i,0)>= dewey && table.getFloat(i,0)<(dewey+1) && table.getString(i,1).substring(0,4).equals(date)){
    if(itemType.startsWith("j") && itemType.endsWith("bk")){
      cbcount += tempcount;
      cbcoutTime += tempcount*tempcoutTime;
    }
    else if(itemType.startsWith("a") && itemType.endsWith("bk")){
      abcount += tempcount;
      abcoutTime += tempcount*tempcoutTime;
    }
    else if(itemType.startsWith("j")&& !itemType.endsWith("bk")){
      cvcount += tempcount;
      cvcoutTime += tempcount*tempcoutTime;
      }
   else if(itemType.startsWith("a")&& !itemType.endsWith("bk")){
      avcount += tempcount;
      avcoutTime += tempcount*tempcoutTime;
      }
    }
    else{
     
    abcoutTime = abcoutTime/abcount;
    avcoutTime = avcoutTime/avcount;
    cbcoutTime = cbcoutTime/cbcount;
    cvcoutTime = cvcoutTime/cvcount;
    int[] countValues = { abcount, avcount, cbcount, cvcount, maxCount};
    maxCount = max(countValues);
    int[] coutValues = { (int)abcoutTime, (int)avcoutTime, (int)cbcoutTime, (int)cvcoutTime, (int)maxcoutTime};
    maxcoutTime = max(coutValues); 
    float tempxcor= map(dewey, 500, 600, -50, 50);
    float tempzcor = map(dateParser(date), 0, 12*14-11, 50, -50);

    if(abcount>=1){
    //float tempycor = map(log(abcount), 0, log(1274), 50, -50);
    float tempycor = map(abcount, 0, 1274, 50, -50);
    abdeweys.add(new Dewey(dewey, date, abcount, abcoutTime, "Adult", "Book", tempxcor, tempycor, tempzcor));
    }
    if(avcount>=1){
    //float tempycor = map(log(avcount), 0, log(1274), 50, -50);
    float tempycor = map(avcount, 0, 1274, 50, -50);
    avdeweys.add(new Dewey(dewey, date, avcount, avcoutTime, "Adult", "Video", tempxcor, tempycor, tempzcor));
    }
    if(cbcount>=1){
    //float tempycor = map(log(cbcount), 0, log(1274), 50, -50);
    float tempycor = map(cbcount, 0, 1274, 50, -50);
    cbdeweys.add(new Dewey(dewey, date, cbcount, cbcoutTime, "Child", "Book", tempxcor, tempycor, tempzcor));
    }
    if(cvcount>=1){
    //float tempycor = map(log(cvcount), 0, log(1274), 50, -50);
    float tempycor = map(cvcount, 0, 1274, 50, -50);
    cvdeweys.add(new Dewey(dewey, date, cvcount, cvcoutTime, "Child", "Video", tempxcor, tempycor, tempzcor));
    }
 
  abcount = 0;
  abcoutTime = 0;
  avcount = 0;
  avcoutTime = 0;
  cbcount = 0;
  cbcoutTime = 0;
  cvcount = 0;
  cvcoutTime = 0;
  
  dewey = int(table.getFloat(i,0));
  date = table.getString(i,1);
      //by year instead
  //date = table.getString(i,1).substring(0,4);

      if(itemType.startsWith("j") && itemType.endsWith("bk")){
      cbcount += tempcount;
      cbcoutTime += tempcount*tempcoutTime;
    }
    else if(itemType.startsWith("a") && itemType.endsWith("bk")){
      abcount += tempcount;
      abcoutTime += tempcount*tempcoutTime;
    }
    else if(itemType.startsWith("j")&& !itemType.endsWith("bk")){
      cvcount += tempcount;
      cvcoutTime += tempcount*tempcoutTime;
      }
   else if(itemType.startsWith("a")&& !itemType.endsWith("bk")){
      avcount += tempcount;
      avcoutTime += tempcount*tempcoutTime;
      }
    
    }
    
  }
  //println(maxCount + "- max count");
  ////1274- max count
  //println(maxcoutTime + "- Max checkout time");
  //1300.0- Max checkout time

 
//noLoop();
}

void draw(){
  //define background color
  background(0);
  
  
  //for(int i=0; i<titles.size(); i++){
  //  color c = colorDetermine(titles.get(i).age, titles.get(i).type);    
  //  float size = 0;
  //      if(titles.get(i).coutTime>0){
  //          size = map(log(titles.get(i).coutTime+1), 0, log(200+1), 0, 5);
  //      }
  //  pushMatrix();
  //  translate(titles.get(i).xcor, 50-titles.get(i).ycor, titles.get(i).zcor);
  //  fill(c);
  //  stroke(c);
  //  strokeWeight(size);
  //  point(0,0,0);
  //  popMatrix();
  //}
    
  

/*

  for(int i=0; i<500; i++){
    println(deweys.get(i).dewey + " " + deweys.get(i).date +
    " " + deweys.get(i).count + " " + deweys.get(i).coutTime +
    " " + deweys.get(i).type + " " + deweys.get(i).age 
    );
  }
*/

  
  //draw big title
  String titleString = "Dewey 500 Checkouts over Time";
  if(setting > 0){
    tempDeweys = allDeweys[setting-1];
    titleString = titleString + " - " + tempDeweys.get(0).age + " " +  tempDeweys.get(0).type + "s";
  }
  textSize(4);
  fill(255);
  text(titleString, -80, -80, 0);
  
 
  //draw dewey Axis Labels
  for(int i=500; i<600; i+=10){
    pushMatrix();
    translate(map(i, 500, 600, -50, 50), 50, -50);
    textSize(2);
    fill(255);
    textMode(SHAPE);
      text(i, 0, 0, 0);
    popMatrix();    
    pushMatrix();
    translate(map(i, 500, 600, -50, 50), 50, 50);
      text(i, 0, 0, 0);
    popMatrix();    
    pushMatrix();
    translate(-60, 50, 50);
    text("Dewey", 0, 0, 0);
    popMatrix();
  }
  //draw date Axis Labels
  for(int i=0; i<12*14-11; i+=12){
    pushMatrix();
    translate(-50, 50, map(i, 0, 12*14-11, 50, -50));
    textSize(2);
    fill(255);
    textMode(SHAPE);
    String tempDate = str(2006+(int)i/12);
      text(tempDate, 0, 0, 0);
    popMatrix();
    pushMatrix();
    translate(-50, 50, 60);
    text("Date", 0, 0, 0);
    popMatrix();
    pushMatrix();
    translate(50, 50, map(i, 0, 12*14-11, 50, -50));
    tempDate = str(2006+(int)i/12);
      text(tempDate, 0, 0, 0);
    popMatrix();
  }

  //draw count Axis Labels
  for(int i=250; i<1274; i+=250){
    //pushMatrix();
    //translate(-50, map(i, 0, 1274, 50, -50), 50);
    textSize(2);
    fill(255);
    textMode(SHAPE);
    //  text(i, 0, 0, 0);
    //popMatrix();
    pushMatrix();
    translate(-50, map(i, 0, 1274, 50, -50), -50);
    text(i, 0, 0, 0);
    popMatrix();
    pushMatrix();
    translate(-50, -50, -50);
    text("Count", 0, 0, 0);
    popMatrix();
    pushMatrix();
    translate(50, map(i, 0, 1274, 50, -50), 50);
    text(i, 0, 0, 0);
    popMatrix();
    pushMatrix();
    translate(50, -50, 50);
    text("Count", 0, 0, 0);
    popMatrix();
    //    pushMatrix();
    //translate(50, map(i, 0, 1274, 50, -50), -50);
    //text(i, 0, 0, 0);
    //popMatrix();
  }
  
  //draw data
  for(int j=0; j<4; j++){
    if(setting>0){
      j=setting-1;
    }
    tempDeweys = allDeweys[j];
    color c = colorDetermine(tempDeweys.get(0).age, tempDeweys.get(0).type);
    fill(c,100); //transparent
    stroke(c, 180); //somewhat transparent
    //strokeWeight(4);
    //draw points if mouseover
    for (int i = 0; i < tempDeweys.size()-1; i++) {
    float size = map(log(tempDeweys.get(i).coutTime+1), 0, log(201), 0, 10);
    strokeWeight(size);
    pushMatrix();
    translate(tempDeweys.get(i).xcor, tempDeweys.get(i).ycor, tempDeweys.get(i).zcor);
    PVector mouse_pos = new PVector(mouseX, mouseY);
    PVector screen_pos = new PVector(screenX(0,0,0), screenY(0,0,0));
    float mouseObjectDist = mouse_pos.dist(screen_pos);
    if(mouseObjectDist < 2){
      //draw point if close
    strokeWeight(size);
    stroke(c); //not transparent
    //point(0,0,0);
    //displays text at point position - always (0,0,0)
    textSize(15);
      //ways to render text (model) or (shape - smoother for 3d)
    fill(c);
    textMode(SHAPE);
      hint(DISABLE_DEPTH_TEST);
      cam.beginHUD();
      text((int)tempDeweys.get(i).dewey + " - " + deweyClasses.getString(((int)tempDeweys.get(i).dewey),1) +  "\n" +
      tempDeweys.get(i).age + " " +  tempDeweys.get(i).type + "s - Count:" +  tempDeweys.get(i).count + ". Average Checkout Time:" 
      + (int)tempDeweys.get(i).coutTime + " days"
      , mouseX,mouseY);
      cam.endHUD();
      hint(ENABLE_DEPTH_TEST);
    }
    point(0,0,0);
    popMatrix();
    fill(c,70);
    strokeWeight(size);
    stroke(c, 180);
    }
    //draw transparent shapes under curves
    // beginShape();
    // vertex(tempDeweys.get(0).xcor, 50 , tempDeweys.get(0).zcor);
    // for (int i = 0; i < tempDeweys.size(); i++) {
    // if(i>0 && (int)tempDeweys.get(i).dewey != (int)tempDeweys.get(i-1).dewey){
    //        vertex(tempDeweys.get(i-1).xcor, 50 , tempDeweys.get(i-1).zcor);
    //  endShape();
    //  beginShape();
    //        vertex(tempDeweys.get(i).xcor, 50 , tempDeweys.get(i).zcor);
    //}
    //vertex(tempDeweys.get(i).xcor, tempDeweys.get(i).ycor, tempDeweys.get(i).zcor);
    //}
    //endShape();
    
    if(setting>0){
      j=4;
    }
  }
    
    
}
void keyPressed(){
  if(setting <4 && key == CODED && (keyCode == UP || keyCode == RIGHT)){
    setting +=1;
  }
  else if(setting>0 && key == CODED && (keyCode == DOWN || keyCode == LEFT)){
    setting -=1;
  }
  if(key == '0'){
    setting = 0;
  }
  if(key == '1'){
    setting = 1;
  }
    else if(key == '2'){
    setting = 2;
  }
    else if(key == '3'){
    setting = 3;
  }
    else if(key == '4'){
    setting = 4;
  }
}
